VERSION 5.00
Begin VB.Form frmMain 
   Caption         =   "ChessRally 2 / Crafty Console - Free Single Player Chess!!"
   ClientHeight    =   6240
   ClientLeft      =   2295
   ClientTop       =   3225
   ClientWidth     =   8430
   Icon            =   "frmMain.frx":0000
   LinkTopic       =   "Form1"
   LockControls    =   -1  'True
   ScaleHeight     =   6240
   ScaleWidth      =   8430
   Begin VB.Timer timerPoll 
      Enabled         =   0   'False
      Interval        =   1
      Left            =   11130
      Top             =   90
   End
   Begin VB.CommandButton cmdSendMove 
      Caption         =   "Send Move"
      Default         =   -1  'True
      Height          =   330
      Left            =   7290
      TabIndex        =   1
      Top             =   5490
      Width           =   1065
   End
   Begin VB.TextBox txMove 
      Height          =   315
      Left            =   75
      TabIndex        =   0
      Top             =   5490
      Width           =   7140
   End
   Begin VB.TextBox txDisplay 
      BeginProperty Font 
         Name            =   "Fixedsys"
         Size            =   9
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   5340
      Left            =   75
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   2
      Top             =   90
      Width           =   8280
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "For complete documentation on Crafty console commands, click here!"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   -1  'True
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00C00000&
      Height          =   195
      Left            =   90
      MouseIcon       =   "frmMain.frx":0442
      MousePointer    =   99  'Custom
      TabIndex        =   3
      Top             =   5925
      Width           =   4920
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private Sub cmdSendMove_Click()
Dim sNewMessage As String
  
    sNewMessage = txMove.Text
    If sNewMessage = "" Then Exit Sub
    
    SendMessageToEngine sNewMessage
    txMove.Text = ""
    txMove.SetFocus

End Sub

Private Sub Form_Activate()
Static BeenHereOnce As Boolean

    If BeenHereOnce Then Exit Sub
    BeenHereOnce = True

    Initialize
    SendMessageToEngine "alarm off"
    SendMessageToEngine "ansi off"
    SendMessageToEngine "st 1"
    SendMessageToEngine "sd 1"

End Sub

Private Sub Label1_Click()

    On Error Resume Next
    
    ExecuteDocument EndingBackslashEnforced(App.Path) & "crafty_doc.txt"

End Sub

Private Sub timerPoll_Timer()
Dim sNewMessage As String
Dim sBuffer As String
Dim sCRLFMarker As String
Dim sDoubledCRLFMarker As String

    On Error Resume Next
    
    'We loop until there are no new messages, so the app doesn't have to risk
    'any messages piling up in the DLL waiting to be processed
    Do
        'Get next message, if available
        sNewMessage = GetNextAvailableEngineMessage()
        If Trim$(sNewMessage) = "" Then
            Exit Do 'No remaining messages... exit loop
        Else
            'Now... preserve message unto string buffer
            Debug.Print sNewMessage
            sBuffer = sBuffer & sNewMessage
        End If
    Loop
    
    'Filter all carriage returns and line feeds into sensible results as needed
    'We're using ASCII char 001 as a "marker", which will be replaced with "good" CRLF pairs
    sCRLFMarker = Chr$(1)
    sDoubledCRLFMarker = sCRLFMarker & sCRLFMarker
    sBuffer = Replace(sBuffer, vbCr, sCRLFMarker) 'Get all "loose" CR's, mark with 001
    sBuffer = Replace(sBuffer, vbLf, sCRLFMarker) 'Get all "loose" LF's, mark with 001
    sBuffer = Replace(sBuffer, vbNullChar, "") 'Kill all null chars
    Do Until InStr(1, sBuffer, sDoubledCRLFMarker) = 0
        sBuffer = Replace(sBuffer, sDoubledCRLFMarker, sCRLFMarker)
    Loop
    sBuffer = Replace(sBuffer, sCRLFMarker, vbCrLf) 'Finally, replace all markers (001) with CRLF pairs
    'That bit may have seemed redundant, but it cn really clean things up...
    
    If sBuffer <> "" Then
        'New message(s) were avaialable
        sBuffer = txDisplay.Text & sBuffer
        If Len(sBuffer) > 16000 Then sBuffer = Right$(sBuffer, 14000) 'Keep things shorter... no reason to have an "infinite buffer"
        txDisplay.Text = sBuffer
        txDisplay.SelStart = Len(sBuffer)
        txDisplay.SelLength = 0
    End If

End Sub

